#include <math.h>
#include <iostream>
#include "4d.h"

using namespace std;

namespace math4d
{
//Vector
	vector:: vector (double a1 = 1.0, double a2 = 1.0, double a3 = 1.0, double a4 = 1.0)
	{
		v[0]=a1;
		v[1]=a2;
		v[2]=a3;
		v[3]=a4;
	}
	vector vector:: operator+= (const vector& a)
	{
		v[0] += a.v[0];
		v[1] += a.v[1];
		v[2] += a.v[2];
		v[3] += a.v[3];
		return *this;
	}
	vector vector:: operator-= (const vector& a)
	{
		v[0] -= a.v[0];
		v[1] -= a.v[1];
		v[2] -= a.v[2];
		v[3] -= a.v[3];
		return *this;
	}
	vector vector:: operator*= (const double& d)
	{
		v[0] *= d;
		v[1] *= d;
		v[2] *= d;
		v[3] *= d;
		return *this;
	}
	void vector:: print ()
	{
		cout <<'('<< v[0] <<' '<< v[1] <<' '<< v[2] <<' ' << v[3] << ')' << '\n';
	}
//OPER
	OPER:: OPER ()
	{
		for (i = 0; i < 4; ++i)
			for (j = 0; j < 4; ++j)
				matrix [i][j] = 0;
		for (i = 0; i < 4; ++i)
			matrix [i][i] = 1;
	}
	void OPER:: print()
	{
		for (i = 0; i < 4; ++i)
		{
			for (j = 0; j < 4; ++j)
			{
				cout.width(10);
				cout << matrix [i][j] << '|';
			}
			
			cout << "\n----------+----------+----------+----------+\n";
		}
	}
	void OPER:: operator() (vector& x)
	{
		x *= *this;
	}
	void OPER:: LoadTurn(double angle, unsigned int axisX, unsigned int axisY, int sw)
	{
		if (sw)
		{
			axisX = ax;
			axisY = ay;
		}
		else 
		{
			ax = axisX;
			ay = axisY;
		}
		--axisX;
		--axisY;
		for (i = 0; i < 4; ++i)
			for (j = 0; j < 4; ++j)
				matrix [i][j] = 0;
		for (i = 0; i < 4; ++i)
			matrix [i][i] = 1;
		if ((axisX == axisY) || (axisX > 4) || (axisY > 4))
		{
			cerr << "Неверно задан базис плоскости поворота\n";
			return;
		}
		matrix[axisX][axisX] = cos(angle);
		matrix[axisY][axisY] = matrix[axisX][axisX];
		matrix[axisY][axisX] = sin(angle);
		matrix[axisX][axisY] = -matrix[axisY][axisX];		
	}
	void OPER:: LoadProj(unsigned int axisX, unsigned int axisY)
	{
		--axisX;
		--axisY;
		for (i = 0; i < 4; ++i)
			for (j = 0; j < 4; ++j)
				matrix [i][j] = 0;
		if ((axisX == axisY) || (axisX > 4) || (axisY > 4))
		{
			cerr << "Неверно задан базис плоскости проекции\n";
			return;
		}
		matrix[axisX][axisX] = 1;
		matrix[axisY][axisY] = 1;
	}
	vector vector::operator*= (const OPER& A)
	{
		int i, j;
		vector temp = *this;
		for (i = 0; i < 4; ++i)
		{
			v[i] = 0;
			for (j = 0; j < 4; ++j)
				v[i] += temp.v[j] * A.matrix[i][j];
		}
		return *this;
	}
//Конец классов.
	vector operator* (const vector& x, const OPER& A)
	{
		vector temp = x;
		return temp *= A;
	}
	vector operator+ (const vector& a, const vector& b)
	{
		vector temp = a;
		return temp += b;
	}
	vector operator- (const vector& a, const vector& b)
	{
		vector temp = a;
		return temp -= b;
	}
	vector operator* (const vector& a, const double& d)
	{
		vector temp = a;
		return temp *= d;
	}
	vector operator* (const double& d, const vector& a)
	{
		vector temp = a;
		return temp *= d;
	}
	vector operator/ (const vector& a, const double& d)
	{
		vector temp = a;
		return temp *= 1/d;
	}
}
